/**
 * This file was generated by the Objective Systems ASN1C Compiler
 * (http://www.obj-sys.com).  Version: 7.5.0, Date: 08-Mar-2021.
 */
#include "X2AP-PDU-Descriptions.h"
#include "X2AP-Constants.h"
#include "rtxsrc/rtxCommon.h"

#include "rtxsrc/rtxPrint.h"

/* functions for populating an InitiatingMessage */
InitiatingMessage *pop_InitMsg (OSCTXT *pctxt);
LoadInformation_protocolIEs_element *pop_LoadInfoElem (OSCTXT *pctxt);
CellInformation_List_element *pop_CellInfoElem (OSCTXT *pctxt); 
ECGI_iE_Extensions_element *pop_ECGIElem (OSCTXT *pctxt);
UL_HighInterferenceIndicationInfo_Item *pop_UL_HIII_InfoItem (OSCTXT *pctxt); 

int main (int argc, char** argv)
{
   /* PDU: X2AP-PDU-Descriptions.X2AP_PDU */
   X2AP_PDU   pdu;
   OSCTXT     ctxt;
   int        i, len, stat;
   OSBOOL     trace = TRUE;
   OSBOOL     verbose = FALSE;
   const char* filename = "message.per";
   const OSOCTET* msgptr;

   /* Process command line arguments */
   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!strcmp (argv[i], "-v")) verbose = TRUE;
         else if (!strcmp (argv[i], "-o")) filename = argv[++i];
         else if (!strcmp (argv[i], "-notrace")) trace = FALSE;
         else {
            printf ("usage: writer [-v] [-o <filename>]  [-notrace]\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 1;
         }
      }
   }

   /* Initialize context structure */
   stat = rtInitContext (&ctxt);
   if (stat != 0) {
      rtxErrPrint (&ctxt);
      return stat;
   }
   rtxSetDiag (&ctxt, verbose);
   pu_setBuffer (&ctxt, 0, 0, TRUE);
   pu_setTrace (&ctxt, trace);

   pdu.t = T_X2AP_PDU_initiatingMessage;
   pdu.u.initiatingMessage = pop_InitMsg (&ctxt);

   if (trace) {
      printf ("The following record will be encoded:\n");
      asn1Print_X2AP_PDU ("X2AP_PDU", &pdu);
      printf ("\n");
   }

   /* Encode */
   if ((stat = asn1PE_X2AP_PDU (&ctxt, &pdu))== 0) {
      if (trace) {
         printf ("Encoding was successful\n");
         printf ("Hex dump of encoded record:\n");
         pu_hexdump (&ctxt);
         printf ("Binary dump:\n");
         pu_bindump (&ctxt, "X2AP_PDU");
      }
   }
   else {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
      rtFreeContext (&ctxt);
      return -1;
   }
   msgptr = pe_GetMsgPtr (&ctxt, &len);

   /* Write the encoded message out to the output file */
   stat = rtxFileWriteBinary (filename, msgptr, len);
   if (stat < 0) {
      printf ("Error opening %s for write access\n", filename);
   }

   rtFreeContext (&ctxt);

   return stat;
}

InitiatingMessage *pop_InitMsg (OSCTXT *pctxt) 
{
   InitiatingMessage* pvalue = rtxMemAllocType (pctxt, InitiatingMessage);
   asn1Init_InitiatingMessage (pvalue);

   pvalue->procedureCode = ASN1V_id_loadIndication;
   pvalue->criticality = Criticality_ignore;

   pvalue->value.t = T_X2PDUDescr_XEP_loadIndication;
   pvalue->value.u.loadIndication = 
      (LoadInformation*)rtxMemAllocZ(pctxt, sizeof(LoadInformation));

   {
      OSRTDList* plist = &pvalue->value.u.loadIndication->protocolIEs;
      LoadInformation_protocolIEs_element* pdata;
      rtxDListInit (plist);

      pdata = pop_LoadInfoElem (pctxt);

      rtxDListAppend (pctxt, plist, (void*)pdata);

   }

   rtxDListInit(&(pvalue->value.u.loadIndication->extElem1));
   return (pvalue);
}

LoadInformation_protocolIEs_element *pop_LoadInfoElem (OSCTXT *pctxt) 
{
   LoadInformation_protocolIEs_element* pvalue = 
      rtxMemAllocType (pctxt, LoadInformation_protocolIEs_element);
   asn1Init_LoadInformation_protocolIEs_element (pvalue);

   pvalue->id = 6;
   pvalue->criticality = Criticality_ignore;
   
   pvalue->value.t = T_X2PDUCont_LoadInformation_IEs_id_CellInformation;
   pvalue->value.u._LoadInformation_IEs_id_CellInformation = 
      rtxMemAllocType (pctxt, CellInformation_List);

   {
      OSRTDList* plist = pvalue->value.u.
         _LoadInformation_IEs_id_CellInformation;
      CellInformation_List_element* pdata;
      rtxDListInit (plist);

      pdata = pop_CellInfoElem (pctxt);

      rtxDListAppend (pctxt, plist, (void*)pdata);

   }
   
   return (pvalue);
}

CellInformation_List_element *pop_CellInfoElem (OSCTXT *pctxt) 
{
   CellInformation_List_element* pvalue = 
      rtxMemAllocType (pctxt, CellInformation_List_element);
   asn1Init_CellInformation_List_element (pvalue);

   pvalue->id = ASN1V_id_CellInformation_Item;
   pvalue->criticality = Criticality_ignore;

   {
      static const OSOCTET testdata[] = { 
      0x6a, 0x3a, 0x67 };
      OSCRTLMEMCPY ((void*)pvalue->value.cell_ID.pLMN_Identity.
         data, testdata, 3);
   }

   pvalue->value.cell_ID.eUTRANcellIdentifier.numbits = 28;
   pvalue->value.cell_ID.eUTRANcellIdentifier.data[0] = 0x4e;
   pvalue->value.cell_ID.eUTRANcellIdentifier.data[1] = 0x4f;
   pvalue->value.cell_ID.eUTRANcellIdentifier.data[2] = 0x50;
   pvalue->value.cell_ID.eUTRANcellIdentifier.data[3] = 0x51;

   pvalue->value.cell_ID.m.iE_ExtensionsPresent = 1;
   {
      OSRTDList* plist = &pvalue->value.cell_ID.iE_Extensions;
      ECGI_iE_Extensions_element* pdata;
      rtxDListInit (plist);

      pdata = rtxMemAllocTypeZ (pctxt, ECGI_iE_Extensions_element);
      pdata = pop_ECGIElem (pctxt);

      rtxDListAppend (pctxt, plist, (void*)pdata);

   }

   rtxDListInit(&(pvalue->value.cell_ID.extElem1));

   pvalue->value.m.ul_InterferenceOverloadIndicationPresent = 1;

   pvalue->value.ul_InterferenceOverloadIndication.n = 1;

   pvalue->value.ul_InterferenceOverloadIndication.elem[0]
       = UL_InterferenceOverloadIndication_Item_high_interference;

   pvalue->value.m.ul_HighInterferenceIndicationInfoPresent = 0;
   pvalue->value.m.relativeNarrowbandTxPowerPresent = 1;
   
   pvalue->value.relativeNarrowbandTxPower.rNTP_PerPRB.numbits = 14;
   {
      OSOCTET* bitData = (OSOCTET*) rtxMemAlloc (pctxt,2);
      bitData[0] = 0x40;
      bitData[1] = 0x34;
      pvalue->value.relativeNarrowbandTxPower.rNTP_PerPRB.
         data = (const OSOCTET*)bitData;
   }

   pvalue->value.relativeNarrowbandTxPower.rNTP_Threshold = 
      RNTP_Threshold_minusInfinity;

   pvalue->value.relativeNarrowbandTxPower.numberOfCellSpecificAntennaPorts
       = RelativeNarrowbandTxPower_numberOfCellSpecificAntennaPorts_one;

   pvalue->value.relativeNarrowbandTxPower.p_B = 1;

   pvalue->value.relativeNarrowbandTxPower.pDCCH_InterferenceImpact = 1;

   pvalue->value.relativeNarrowbandTxPower.m.iE_ExtensionsPresent = 0;

   rtxDListInit(&(pvalue->value.relativeNarrowbandTxPower.extElem1));

   pvalue->value.m.iE_ExtensionsPresent = 0;
   rtxDListInit(&(pvalue->value.extElem1));

   return (pvalue);
}

ECGI_iE_Extensions_element *pop_ECGIElem (OSCTXT *pctxt) {
   ECGI_iE_Extensions_element* pvalue = 
      rtxMemAllocType (pctxt, ECGI_iE_Extensions_element);
   asn1Init_ECGI_iE_Extensions_element (pvalue);
   
   pvalue->id = 1;
   pvalue->criticality = Criticality_notify;

   /* Populate OpenType */
   {
      static const OSOCTET testdata[] = {0x04, 0x08, 
      0x3f, 0xc4, 0x8f, 0xc4, 0x7a, 0x18, 0xdb, 0xad,  };
      pvalue->extensionValue.data = (const OSOCTET*)rtxMemAllocZ(pctxt, 10);
      pvalue->extensionValue.numocts = 10;
      OSCRTLMEMCPY ((void*)pvalue->extensionValue.data, testdata, 10);
   }
   
   return (pvalue);
}

UL_HighInterferenceIndicationInfo_Item *pop_UL_HIII_InfoItem (OSCTXT *pctxt) {
   UL_HighInterferenceIndicationInfo_Item* pvalue = 
      rtxMemAllocType (pctxt, UL_HighInterferenceIndicationInfo_Item);
   
   asn1Init_UL_HighInterferenceIndicationInfo_Item (pvalue);

   pvalue->ul_interferenceindication.numbits = 10;
   {
      OSOCTET* bitData = (OSOCTET*) rtxMemAlloc (pctxt,2);
      bitData[0] = 0x69;
      bitData[1] = 0x34;
      pvalue->ul_interferenceindication.data = (const OSOCTET*)bitData;
   }

   {
      static const OSOCTET testdata[] = { 
      0xcf, 0xef, 0xda };
      OSCRTLMEMCPY ((void*)pvalue->target_Cell_ID.pLMN_Identity.
         data, testdata, 3);
   }

   pvalue->target_Cell_ID.eUTRANcellIdentifier.numbits = 24;
   pvalue->target_Cell_ID.eUTRANcellIdentifier.data[0] = 0x5a;
   pvalue->target_Cell_ID.eUTRANcellIdentifier.data[1] = 0x71;
   pvalue->target_Cell_ID.eUTRANcellIdentifier.data[2] = 0x44;
   pvalue->target_Cell_ID.eUTRANcellIdentifier.data[3] = 0x50;

   pvalue->target_Cell_ID.m.iE_ExtensionsPresent = 0;
   
   rtxDListInit(&(pvalue->target_Cell_ID.extElem1));

   pvalue->m.iE_ExtensionsPresent = 0;

   rtxDListInit(&(pvalue->extElem1));

   return (pvalue);
}

